<template>
    <ModalLayer v-if="render" @close="switchRender">
        <ModalForm>
            <div v-if="isMobile" class="modal__control_mobile">
                <div class="modal-form-row mb-0">
                    <BtnWithIcon v-if="action === 'update'" icon="comments" @click.native="isDetail = !isDetail"/>
                    <BtnWithIcon v-if="action === 'update'" icon="history" @click.native="isHistory = !isHistory"/>
                </div>
                <button disabled ref="btn" type="button" v-if="action === 'create'" @click="create" class="modal-btn-sky">Добавить задачу</button>
                <button :disabled="disabled" ref="btn" type="button" v-if="action === 'update'" @click="update" class="modal-btn-sky">Сохранить</button>
            </div>

            <div class="form-wrapper">
                <div v-if="action === 'create'" class="modal-form-title">Создание новой задачи</div>
                <div v-if="action === 'update'" class="modal-form-title">Редактирование задачи</div>
                <ModalCloseBtn @click.native="switchRender"/>
            </div>

            <el-tag v-role="Role.ADMIN" class="modal-mb-default" v-if="mark" type="info" size="mini">{{this.task.mark}}</el-tag>

            <div class="field-wrapper">
                <textarea v-role:any.disabled="`${Role.ADMIN}`" @input="title.length ? $refs['btn'].disabled = false : $refs['btn'].disabled = true" v-focus maxlength="600" v-model="title" id="title" class="modal-form-textarea" placeholder="Введите описание задачи"></textarea>
            </div>

            <Subtasks v-if="action === 'create' && online"
                      :disabled="disabled"
                      @add="subtask => $store.commit('subtask/add', subtask)"
                      @update="subtask => $store.commit('subtask/update', subtask)"
                      @remove="id => $store.commit('subtask/delete', id)"/>

            <Subtasks v-if="action === 'update' && online"
                      :disabled="disabled"
                      @add="subtask => $store.dispatch('subtask/create', {taskId, subtask})"
                      @update="subtask => $store.dispatch('subtask/update',{taskId, subtask})"
                      @remove="subtaskId => $store.dispatch('subtask/delete', {taskId, subtaskId})"/>

            <ExecutorCreate @select="select"
                            :target="responsible"
                            @add="$store.commit('executor/add', {id: uuid(), fullName: '', isLocal: true})"/>

            <Executors v-if="online" :executors="executors"
                       @remove="({id, isLocal}) => isLocal ?
                            $store.commit('executor/delete', id) :
                            $store.dispatch('executor/delete', {taskId, executorId: id})"/>

            <div class="modal-form-wrapper-items-2">
                <div class="field-wrapper">
                    <select v-role.disabled="Role.ADMIN" v-model="task.icon" id="action" class="modal-form-select" >
                        <option value="">Выберите действие</option>
                        <option v-for="item of actions" :key="item.id" :value="item.description">{{item.description}}</option>
                    </select>
                </div>

                <div class="field-wrapper">
                    <input v-role.disabled="Role.ADMIN" v-model="term" id="date" type="date" class="modal-form-date"/>
                </div>
            </div>

            <div class="field-wrapper">
                <SearchProjects :action="action" :value="task.project || ''" @select="project => task.project = project">
                    <input v-role.disabled="Role.ADMIN" maxlength="350" autocomplete="off" v-model.trim="task.project" type="text" class="modal-form-input search-input" placeholder="Введите название проекта"/>
                </SearchProjects>
            </div>

            <div class="field-wrapper">
                <select v-role.disabled="Role.ADMIN" v-model="task.status" class="modal-form-select" >
                    <option v-for="value of $store.getters['task/getStatus']" :value="value">{{value}}</option>
                </select>
            </div>

            <Mark v-role="Role.CONTROL"/>

            <UploadFiles v-if="action === 'create' && online"
                         @add="file => $store.commit('taskFile/add', file)"
                         @remove="fileId => $store.commit('taskFile/delete', fileId)"/>
            <UploadFiles v-if="action === 'update' && online"
                         @add="file => $store.dispatch('taskFile/upload', {taskId, file})"
                         @remove="fileId => $store.dispatch('taskFile/delete', {taskId, fileId})"/>

            <HistoryLogs v-if="action === 'update' && isHistory" :id="taskId"/>

            <div v-if="isDetail && action === 'update'">
                <Comments/>
            </div>

            <div v-if="!isMobile" class="form-wrapper mb-0 modal__footer">
                <button v-role.disabled="Role.ADMIN" ref="btn" type="button" v-if="action === 'create'" @click="create" class="modal-btn-sky">Добавить задачу</button>
                <button v-role.disabled="Role.ADMIN" ref="btn" type="button" v-if="action === 'update'" @click="update" class="modal-btn-sky">Сохранить</button>
                <button v-role="Role.ADMIN" ref="btn" type="button" v-if="action === 'update'" @click="remove" class="modal-btn-red">Удалить</button>
<!--                <button ref="btn" type="button" v-if="action === 'update' && isRevisionMode && task.version === versions[0]" @click="revision" class="modal-btn-sky">Ревизия</button>-->
<!--                <button ref="btn" type="button" v-if="action === 'update' && isRevisionMode && task.version === versions[1]" @click="revision" class="modal-btn-sky">Вернуться к старой версии</button>-->
                <div v-if="online" class="modal-form-row mb-0">
                    <BtnWithIcon @click.native="isHistory = !isHistory" v-if="action === 'update'" icon="history" title="История"/>
                    <BtnWithIcon icon="comments" title="Комментарии" @click.native="isDetail = !isDetail"/>
                </div>
            </div>
        </ModalForm>
    </ModalLayer>
</template>

<script>
    import moment from 'moment'
    moment.locale('ru')
    import {EventBus} from "@/main"
    import {mapGetters} from 'vuex'
    import store from '@/store'
    import {v4 as uuid} from 'uuid'
    import revision from "@/components/v-mixins/revision"
    import {EventSystem} from "@/config/event.ts";

    const ModalLayer = () => import('@/components/ModalWindows/ModalLayer.vue')
    const ModalForm = () => import('@/components/ModalWindows/Elements/ModalForm.vue')
    const ModalCloseBtn = () => import('@/components/ModalWindows/Elements/ModalCloseBtn.vue')
    const ButtonAdd = () => import('@/components/Buttons/ButtonAdd.vue')
    const ButtonRemove = () => import('@/components/Buttons/ButtonRemove.vue')
    const UploadFiles = () => import('@/components/ModalWindows/Elements/UploadFiles.vue')
    const Comments = () => import('@/components/ModalWindows/Elements/Comments.vue')
    const Subtasks = () => import('@/components/ModalWindows/Elements/subtask/Subtasks.vue')
    const Executors = () => import('@/components/ModalWindows/Elements/Executors.vue')
    const ExecutorCreate = () => import('@/components/ModalWindows/Elements/ExecutorCreate.vue')
    const HistoryLogs = () => import('@/components/ModalWindows/Elements/HistoryLogs.vue')
    const BtnWithIcon = () => import('@/components/ModalWindows/Elements/BtnWithIcon.vue')
    const SearchExecutors = () => import('@/components/ModalWindows/Elements/search/SearchExecutors.vue')
    const SearchProjects = () => import('@/components/ModalWindows/Elements/search/SearchProjects')
    const Mark = () => import('@/components/ModalWindows/Elements/Mark.vue')

    const {dispatch, commit} = store

    export default {
        name: 'ModalCreationTask',
        mixins: [revision],
        watch: {
            'render': function () {!this.render ? this.$router.replace({query: {}}).catch(()=>{}) : null},
            '$route': function () {this.$route.name !== 'boardById' ? this.render = false : null},
            '$route.query.task': function () {
                const id = +this.$route.query.task
                if (Number.isInteger(id))
                    EventBus.$emit(EventSystem.SWITCH_MODAL_EDITION_TASK, {action: 'update', id})
                else this.$router.replace({query: {}}).catch(()=>{})
            },
        },
        data: () => ({
            title: '',
            taskId: null,
            action: null,
            flag: null,
            render: false,
            term: '',
            mark: '',
            responsible: {id: uuid(), fullName: ''},
            isDetail: false,
            isHistory: false,
            loading: true,
            disabled: false
        }),
        computed: {
            id() {return +this.$route.params.id},
            ...mapGetters({
                actions: ['task/getIcons'],
                task: ['task/getTask'],
                projects: ['project/getProjects'],
                users: ['board/getUsers'],
                representation: ['board/getRepresentation'],
                isMobile: ['viewport/isMobile'],
                isRevisionMode: ['board/getRevisionMode'],
                versions: ['board/getVersions'],
                online: ['network/getOnline'],
                subtasks: ['subtask/getSubtasks'],
                comments: ['comment/getComments'],
                executors: ['executor/getExecutors'],
                files: ['taskFile/getFiles'],
            }),
        },
        methods: {
            uuid,
            getFullName(value) {
                if (value) {
                    const firstName = value.split(' ')[0]
                    const lastName = value.split(' ')[1] || ''
                    if (lastName || firstName)
                        return `${firstName} ${lastName}`
                } else return ''
            },
            select({id, fullName, executorId}) {
                this.responsible.id = executorId
                this.responsible.fullName = fullName
            },
            resetParams() {
                commit('subtask/setSubtasks', [])
                commit('taskFile/setFiles', [])
                commit('executor/setExecutors', [])
                this.title = ''
                this.task.project = ''
                this.task.icon = ''
                this.responsible = {id: uuid(), fullName: ''}
                this.term = ''
                this.isDetail = false
            },
            getParams() {
                const title = this.title
                const responsible = !this.responsible.fullName ? {id: uuid(), fullName: ''} : this.responsible
                const project = this.task.project
                const status = this.task.status
                const term = moment(this.term.trim(), 'YYYY-MM-DD').format('YYYY-MM-DD')
                const icon = this.task.icon ? this.task.icon : null
                const files = this.files
                const subtasks = this.subtasks
                const executors = this.executors
                return {title, term, project, icon, status, files, subtasks, responsible, executors}
            },
            create() {
                const params = this.getParams()
                !this.term ? delete params.term : null
                !this.files.length ? delete params.files : null

                if (this.title) {
                    dispatch('task/create', {id: this.id, params})
                        .then(() => dispatch('board/getById', this.id))
                    this.switchRender()
                }
            },
            update() {
                const params = this.getParams()
                delete params.files
                params.term === 'Invalid date' ? params.term = null : null
                EventBus.$emit('renderTaskPreloader', this.task.id)
                dispatch('task/update', {id: this.taskId, params}).then(() => EventBus.$emit('disableTaskPreloader', this.task.id))
                this.switchRender()
            },
            remove() {
                const message = 'После удаления, восстановление не возможно.'
                this.$confirm(message, {confirmButtonText: 'ОК', cancelButtonText: 'Отмена', type: 'warning'}).then(() => {
                    dispatch('task/delete', this.taskId)
                    this.switchRender()
                }).catch(() => {})
            },
            switchRender() {this.render = !this.render},
        },
        mounted() {
            const close = e => e.keyCode === 27 ? this.render = false : null
            window.addEventListener('keydown',  close)
        },
        created() {
            EventBus.$on(EventSystem.SWITCH_MODAL_CREATION_TASK, payload => {
                this.resetParams()
                const {action, flag} = payload
                this.action = action
                flag ? this.flag = flag : null
                flag === 'project' ? this.task.project = payload.project : null
                this.switchRender()
            })
            EventBus.$on(EventSystem.SWITCH_MODAL_EDITION_TASK, payload => {
                this.resetParams()
                const {action, id} = payload
                this.action = action
                this.taskId = id
                this.$router.push({query: {taskId: this.taskId}}).catch(() => {})

                dispatch('task/getById', id).then(() => {
                    const {title, icon, term, responsible, mark} = this.task
                    this.title = title
                    this.task.icon = icon ?? ''
                    this.term = term ? term.split('T')[0] : ''
                    this.mark = mark ? mark : ''
                    this.responsible = responsible ? responsible : {id: uuid(), fullName: ''}
                    this.switchRender()
                })
            })
        },
        components: {ExecutorCreate, HistoryLogs, ButtonAdd, ButtonRemove, ModalLayer, ModalCloseBtn, ModalForm, UploadFiles, Comments, Subtasks, Executors, BtnWithIcon, SearchExecutors, SearchProjects, Mark}
    }
</script>

<style scoped lang="scss">
    .modal-table-wrapper {@include flex(space-between);}
    .col-left {width: 55.6%;}
    .col-right {width: 42.8%;}
    @media only screen and (max-width: 480px) {
        .modal__footer {
            flex-direction: column;
            > .form-control {margin: 0 0 1.66rem 0;}
        }
        .modal__control_mobile {
            @include flex(space-between, center);
            padding: 0 0 .83rem 0;
            margin: 0 0 .83rem 0;
            position: relative;
            ::before {
                content: "";
                position: absolute;
                width: 200%;
                height: 1px;
                background-color: #E3ECF3;
                bottom: 0;
                left: -50%;
                pointer-events: none;
            }
        }
    }
</style>
